#
#  Linux Desktop Testing Project http://www.gnomebangalore.org/ldtp
#
#  Author:
#     Poornima <pnayak@novell.com>
#
#  Copyright 2004 Novell, Inc.
#
#  This test script is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.
#

#To create an Memo without attachment
from evoutils.calendar import *
from ldtputils import *

#Initialising XML parser with data file
data_object = LdtpDataFileParser (datafilename)

#Extracting imput data from xml file
classification = data_object.gettagvalue ('classification')[0]
group = data_object.gettagvalue ('group')[0]
category = data_object.gettagvalue ('categories')[0]
memo_content = data_object.gettagvalue ('memo_content')[0]

log ('Memo Creation', 'teststart')

try:
	windowname = 'dlgJournalentry-Nosummary'
	flag = 0
	
        if selectmenuitem ('frmEvolution-Memos', 'mnuView;mnuWindow;mnuMemos1') ==0:
		log ('Failed to goto  memo window', 'cause')
		raise LdtpExecutionError (0)

	time.sleep (2)
	selectmenuitem ('frmEvolution-Memos', 'mnuFile;mnuFile;mnuMemo')
	time.sleep (2)
	
	if guiexist (windowname) == 0:
		log ('Failed to open new memo window', 'cause')
		raise LdtpExecutionError (0)

	if comboselect ('dlgJournalentry-Nosummary', 'cboClassification', classification) == 0:
		log ('Failed to select classification as ' + classification, 'cause')
		raise LdtpExecutionError (0)

	if comboselect ('dlgJournalentry-Nosummary', 'cboGroup', group) == 0:
                log ('Failed to select Group as ' + group, 'cause')
                raise LdtpExecutionError (0)

	click ('dlgJournalentry-Nosummary', 'btnCategories')
	time.sleep (2)

	if select_catagory (category) == 0:
		log ('Failed to select category ' + category, 'cause')
		raise LdtpExecutionError (0)

	if setandverify ('dlgJournalentry-Nosummary', 'txt0', memo_content) == 0:
		log ('Failed to set value in Memo content field ' + memo_content, 'cause')
		raise LdtpExecutionError (0)

	if stateenabled ('dlgJournalentry-Nosummary', 'btnOK') == 1:
	        click ('dlgJournalentry-Nosummary', 'btnOK')
		time.sleep (2)
        else:
		log ('OK Button is in disabled state!!', 'warning')
		click ('dlgJournalentry-Nosummary', 'btnCancel')
	
	time.sleep (3)
	if waittillguinotexist ('dlgJournalentry-Nosummary') == 0:
		log ('Failed to close Memo dialog' ,'cause')
		raise LdtpExecutionError (0)
		
	time.sleep (2)

	# Verify memo is created 
	if selectlastrow ('frmEvolution-Memos', 'tblMemoTable') ==0:
		log ('Failed to open last Memo in list of memos' ,'cause')
		raise LdtpExecutionError (0)

	selectmenuitem ('frmEvolution-Memos', 'mnuFile;mnuFile;mnuOpenMemo')
	time.sleep (2)
	windowname = 'dlgJournalentry-Nosummary'

	setcontext ('Journal entry - No summary', 'Journal entry - ' + memo_content)
	if guiexist (windowname) == 0:
		log ('Failed to open memo window ' + memo_content, 'cause')
		raise LdtpExecutionError (0)

	if verifysettext (windowname, 'cboClassification', classification) == 0:
		log ('Classification field is not set to ' + classification, 'cause')
		raise LdtpExecutionError (0)

	'''
	#uncomment it later, needs changes in combo_box.c
	if verifysettext (windowname, 'cboGroup', group) == 0:
		log ('Group field is not set to ' + group, 'cause')
		raise LdtpExecutionError (0)
	'''

	if verifysettext (windowname, 'txt0', memo_content) == 0:
		log ('Memo content field is not set to ' + memo_content, 'cause')
		raise LdtpExecutionError (0)
				
	click (windowname, 'btnCancel')
	time.sleep (3)
	if waittillguinotexist ('dlgJournalentry-Nosummary') == 0:
		log ('Failed to close Memo dialog' ,'cause')
		raise LdtpExecutionError (0)
	
	releasecontext ()
		
	log ('Memo created and verified', 'pass')
				
except ldtp.error, msg:
	log ('Create memo failed, ' + str(msg), 'error')
		
