#!/usr/bin/python
#
#  Linux Desktop Testing Project http://www.gnomebangalore.org/ldtp
#
#  Author:
#     Premkumar <jpremkumar@novell.com>
#
#  Copyright 2004 Novell, Inc.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.
#
from ldtp import *
from ldtputils import *

#To set and verify a textbox
def setandverify (win_name, box_name, value):
    try:
        settextvalue (win_name, box_name, value)
        if verifysettext (win_name, box_name, value) == 0:
            return 0
        return 1
    except:
        return 0

                                        
#To populate mail header
def populate_mail_header (to, subject,body,
                          cc = '', bcc = ''):
    try:
        if to!='' and setandverify ('frmComposeamessage', 'txtTo', to) == 0:
            log ('Failed to insert text into To field','error')
            raise LdtpExecutionError (0)
        if cc != '' and setandverify ('frmComposeamessage',
                                      'txtCc', cc) == 0:
            log ('Failed to insert text into Cc field','error')
            raise LdtpExecutionError (0)
        #Note: I have edited the evolution.map to change 'txt0'
        #to 'txtSubject'
        
        #cant use set and verify since context switching is involved
        if subject!='':
            settextvalue ('frmComposeamessage', 'txt1', subject)
            setcontext ('Compose a message', subject)
            time.sleep(3)
            if verifysettext ('frmComposeamessage', 'txt1',
                              subject) == 0:
                log ('Failed to insert text into subject Field','error')
                raise LdtpExecutionError (0)
        #TODO: Change 'txt6' to some meaningful name in
        #evolution.map also in the following code
        if body!='' and setandverify ('frmComposeamessage', 'txt7',
                                      body) == 0:
            log ('Failed to insert text into Body field','error')
            raise LdtpExecutionError (0)
        #TODO: Check bcc field
        return 1
    except:
        print 'Compose new message failed '
        log ('Compose new message failed', 'Fail' )

#To capture image of the ith mail in the given folder
def capturemailimage (folder_name, i, filename):
    try:
        #selectmenuitem ('evolution','mnuView;mnuWindow;mnuMail')
        time.sleep (3)
        selectrowpartialmatch ('evolution', 'ttblMailFolderTree', folder_name)
        time.sleep (3)
        if i == '-1':
            i = str (getrowcount ('evolution', 'ttblMessageList') - 1)
        print 'The obtained index is i = ' + str(i)
        selectrowindex ('evolution', 'ttblMessageList', int(i))
        time.sleep (3)    
        subject = getcellvalue ('evolution', 'ttblMessageList', int (i), 4)
        time.sleep (2)
        selectmenuitem ('evolution', 'mnuMessage;mnuOpeninNewWindow')
        time.sleep (3)
        setcontext ('Readonlyframe', subject)
        time.sleep (3)
        if guiexist ('Readonlyframe') == 0:
            log ('Readonlyframe failed to open', 'cause')
            raise LdtpExecutionError (0)
        time.sleep (3)
        imagecapture (subject, 'IMAGES/'+filename)
        time.sleep (3)
        selectmenuitem ('Readonlyframe', 'mnuFile;mnuClose')
        time.sleep(3)
        if guiexist ('Readonlyframe') == 1:
            log ('Message Window is not close after capturing', 'warning')
            raise LdtpExecutionError (0)
        releasecontext ()
        return 1
    except ldtp.error, msg:
        print 'Failure: ' + str(msg) 
        log ('Capturing of mail failed','warning')
        LdtpExecutionError(0)
        
#To verify the ith mail in the given folder with the given image
def verifymailwithimage (folder_name, mail_index, refimg_filename):
    try:
        print 'Refernce Image Filename' + refimg_filename
        capturemailimage (folder_name, mail_index, 'cur_mail.png')
        print 'The difference in image is:' + str (imagecompare ('IMAGES/cur_mail.png', refimg_filename))
        if imagecompare ('IMAGES/cur_mail.png', refimg_filename) < 0.2:
            return 1
        else:
            return 0
    except ldtp.error, msg:
        print 'Comparision failed due to the following error -' + str (msg)
        log ('Comparision of mail images failed - ref image: ' + refimg_filename , 'error')
        LdtpExecutionError (0)
            

