#!/usr/bin/python
#
#  Linux Desktop Testing Project http://www.gnomebangalore.org/ldtp
#
#  Author:
#     Premkumar <jpremkumar@novell.com>
#
#  Copyright 2004 Novell, Inc.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the
#  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
#  Boston, MA 02111-1307, USA.
#
from ldtp import *
from ldtputils import *
from evoutils.mail import *

#To insert values into an Recurrence tab
def insert_status (windowname, ptlistname, status = 'In Progress', percomplete = '10', priority = 'Normal',
                   datecompleted = 'TODO', webpage = 'none'):
     try: 
         selecttab (windowname, ptlistname, '1')
         time.sleep (2)
         comboselect (windowname, 'cboNotStarted', status)
         #TODO: Use verifyselect to verify the previous operation. Currently could not do
         #due to ambiguity in the searching algorithm used
         setvalue (windowname, 'sbtnPercentComplete', percomplete)

         comboselect (windowname, 'cboUndefined', priority)
         #TODO: Use verifyselect to verify the previous operation. Currently could not do
         #due to ambiguity in the searching algorithm used

         if webpage != 'none':
              if setandverify (windowname, 'txtWebPage', webpage) == 0:
                   log ('Setandverify failed in txtWebPage', 'cause')
                   raise LdptExecutionError (0)              
              else:
                   if datecompleted != 'null':
                        if setandverify (windowname, 'txtTextDateEntry', datecompleted) == 0:
                             log ('Setandverify failed in txtWebPage', 'cause')
                             raise LdptExecutionError (0)
     except error,msg:
          print "Problem in inserting status details " + str (msg)
          log ('Error in staus tab','error')


#To insert values into an Appointment tab
def insert_task (windowname, ptlistname, summary, description, date0, time0,
                        date1, time1, classification = 'Public', categories = 'Business'):
     try:
         print 'windowname is: ' + windowname
         print 'tablist name is: ' + ptlistname
         #selecttab (windowname, ptlistname, '0')
         time.sleep (2)
         settextvalue (windowname,'txtSummary', summary)
         if windowname == 'dlgTask-Nosummary':
              setcontext ('Task - No summary', 'Task - ' + summary)
         else:
              setcontext ('AssignedTask - No summary', 'Task - ' + summary)
         time.sleep (2)
         comboselect (windowname, 'cboPublic', classification)
         #TODO: Use verifyselect to verify the previous operation. Currently could not do
         #due to ambiguity in the searching algorithm used

         click (windowname, 'btnCategories')
         time.sleep (3)
         if guiexist ('dlgCategories') == 0:
              log ('Failed to open categories dialog', 'cause')
              raise LdtpExecutionError (0)
         else:              
              #NOTE: Here is a small work around for selecting the category because of unclear
              #behaviour of the table in the category dialog.
              index = gettablerowindex ('dlgCategories', 'tbl0', categories )
              selectrowindex ('dlgCategories', 'tbl0', index + 1)
              time.sleep (2)
              checkrow ('dlgCategories', 'tbl0', index)
              time.sleep (2)
              if verifysettext ('dlgCategories', 'txt0', categories) == 0:
                   log ('Failed to select given category', 'cause')
                   raise LdtpExecutionError (0)
              else:
                   click ('dlgCategories', 'btnOK')
                   time.sleep (1)
                   if guiexist ('dlgCategories') == 1:
                        log ('Failed to close Category dialog', 'cause')
                        raise LdtpExecutionError (0)
                   else:
                        if  setandverify (windowname, 'txtTaskDescription', description) == 0:
                             log ('Failed to set value in Event description field', 'cause')
                             raise LdtpExecutionError (0)
                        #else:
                             #FIXME: Because of appmap generating same label for both the date fields
                             #could not set date into first field
                             #settextvalue (windowname, 'txtTextDateEntry2', date0)
                             #settextvalue (windowname, 'txtTextDateEntry1', date1)
     except error,msg:
          print "Problem in inserting appointment details " + str (msg)
          log('errorinappointmenttab','error')

